

*************************************************************************
* Program LAB10A.ASM will produce a 1 KHz squarewave output at pin OC2(PA6)
* For 1KHz, Period = 1ms, Half-Period = 0.5 ms
* For E-clock fre. of 2 MHz,
* For 'pre-scaler' of 1, Timer Counts = 0.5 ms/0.5s = 1,000

*************************************************************************
* Instructions to be completed by students *
*************************************************************************

COUNTS      EQU        1000T      ;no. of timer clocks, must be < 65,536
TCNT        EQU        $0E      ;(or max. two-byte value)
TCTL1       EQU        $20      ;OM2:OL2 = 0:1 for toggle-mode of OC2(PA6)
TFLG1       EQU        $23        ;T-Flag reg.- bit 6 is 'OC2F'
TMSK2       EQU        $24        ;PR0 & PR1=00 for Timer-Clk Pre-scaler of '1'
TOC2        EQU        $18      ;$1018/$1019 = OC2 reg.
PORTA       EQU        $1000


            ORG        $FFFE
            FDB        START         ;reset Vector

            ORG        $E000         ;program origin: address $E000
START       LDX        #$1000        ;init IX=$1000

*Timer Clock: Pre-scaler setting (1, 4, 8 or 16)
            LDAA       #$00          ;Pre-scaler = 1
            STAA       TMSK2,X

            LDS        #$00FF        ;init Stack
            LDAA       #$40          ;--> 01000000
            STAA       ....,x        ;configure OC2 in toggle-mode
            STAA       ... ,x        ;clear OC2-Flag

AGAIN       LDD        TCNT,x        ;prepare TOC2 for 0.5ms delay
            ADDD       #COUNTS       ;add timer counts for time-delay
            STD        TOC2,x        ;store in TOC2 reg. for time compare
WAIT        BRCLR      TFLG1,X,$40,WAIT ;wait for OC2F to set and triggers OC2
            LDAA       #$..          ;clear OC2-Flag
            STAA       TFLG1,X
            BRA        AGAIN         ;





