

*************************************************************************
* Program LAB10B.ASM will produce a waveform with unequal MARK and SPACE
* at OC2 output using Output-compare operation
* E-clock of 2 MHz
*************************************************************************

MARK        EQU        65000T     ;no. of timer counts for MARK
SPACE       EQU        65000T     ;no. of timer counts for SPACE
TCNT        EQU        $0E      ;
TCTL1       EQU        $20      ;OM2:OL2 = 0:1 for toggle-mode of OC2(PA6)
TFLG1       EQU        $23        ;T-Flag reg.- bit 6 is 'OC2F'
TMSK2       EQU        $24        ;PR1,0 is  Timer clk Pre-scaler
TOC2        EQU        $18      ;$1018/$1019 = OC2 reg.
CFORC       EQU        $0B      ;Force reg.- force OC2
PORTA       EQU        $1000

            ORG        $FFFE
            FDB        START

            ORG        $E000         ;program origins, address $E000
START       LDX        #$1000        ;init IX=$1000
            LDS        #$00FF        ;set stack pointer
            LDAA       #$00          ;Timer Pre-scaler of 1
            STAA       TMSK2,X

* Initially, force OC2 to go LOW
            LDAA       #$80          ;enable OC2 output for LOW
            STAA       TCTL1,X       ;
            LDAA       #$40
            STAA       CFORC,X       ;force OC2 output to LOW
            LDAA       #$40          ;set OC2 for toggling mode
            STAA       TCTL1,X       ;
CYCLE       BSR        LOW
WAIT_LOW    BRCLR      TFLG1,X,$40,WAIT_LOW ;wait for OC2 trigger & goes HIGH
            BSR        HIGH
WAIT_HIGH   BRCLR      TFLG1,X,$40,WAIT_HIGH ;wait for OC2 trigger & goes LOW
            BRA        CYCLE

* subroutine to set time-delay for MARK
HIGH        LDD        TCNT,X        ;prepare TOC2 for MARK
            ADDD       #MARK         ;add timer counts for MARK
            STD        TOC2,X
            LDAA       #$40          ;clear OC2 Flag
            STAA       TFLG1,X
            RTS

* subroutine to set time-delay for SPACE
LOW         LDD        TCNT,X        ;prepare TOC2 for SPACE
            ADDD       #SPACE        ;add timer counts for SPACE
            STD        TOC2,X
            LDAA       #$40          ;clear OC2 Flag
            STAA       TFLG1,X
            RTS



