

*************************************************************************
* Program LAB10C.ASM will measure the Pulse-Width of voltage pulse
* at IC1 input using Input-Capture operation

* E-clk fre. of 2 MHz, pre-scaler of 1 upon reset
* This works for limited value of pulse-width
*************************************************************************
PULSE       EQU        $0010
FALLTIME    EQU        $0008
RISETIME    EQU        $0000

TCNT        EQU        $0E      ;(or max. two-byte value)
TCTL2       EQU        $21      ;input-edge select
TFLG1       EQU        $23      ;T-Flag reg.- bit 2 is 'IC1F'
TMSK2       EQU        $24      ;PR1,0 is  Timer clk Pre-scaler
TIC1        EQU        $10      ;
PORTA       EQU        $00
PORTB       EQU        $04
PORTC       EQU        $03
DDRC        EQU        $07

            ORG        $FFFE
            FDB        START

            ORG        $E000         ;program origins, address $E000
START       LDX        #$1000        ;init IX=$1000
            LDS        #$00FF
            LDAA       #$00
            STAA       TMSK2,X
            LDAA       #$FF
            STAA       DDRC,X

* Initially,
            LDAA       #%00100000    ;init IC1 to detect Falling-edge
            STAA       TCTL2,X       ;
            LDAA       #$04
            STAA       TFLG1,X       ;clear IC1 Flag
            BSET       PORTB,X,$55

POLLFALL    BRCLR      TFLG1,X,$04,POLLFALL  ;  poll IC1 Flag
            LDD        TIC1,X          ;IC1F set - read time
            STD        FALLTIME      ;and save fall-time

            LDAA       #%00010000    ;init IC1 to detect Rising-edge
            STAA       TCTL2,X
            LDAA       #$04          ;clear IC1F
            STAA       TFLG1,X

POLLRISE    BRCLR      TFLG1,X,$04,POLLRISE  ;poll IC1F
            LDD        TIC1,X        ;read Rise-time
            STD        RISETIME      ;save Rise-time

* Monitor Rise-time on LEDs
            STAA       PORTB,X       ;show Rise-Time in ports B/C LEDs
            STAB       PORTC,X

            SUBD       FALLTIME      ;subtract Fall-time
            STD        PULSE         ;store result in PULSE

* set BR at $E040 to see results
* BR E040--GO--press PA2 switch
            NOP
RE2         BRA        RE2





