*******************************************************************************
* Program LAB4A.ASM : Familiarisation with operations of some 68HC11's instructions
*******************************************************************************
      ORG   $E000
* Data Handling instructions
      LDAA  #$01     ;load A with '$01'
      LDAB  #$A5     ;load B with '$A5'
      LDX   #$0004   ;load X with '$0004'- a 2-byte value
      STAA  $0000    ;store [A] to memory address $0000
      STAB  $0001    ;store [B] to memory address $0001
      STX   $0003    ;store [X] to memory addresses $0003 and $0004
      LDAA  $0001    ;load A from memory address $0001
      LDAB  0,X      ;load B from memory address [X]+0
*Transfer and clear data
      CLRA           ;clear A (to zero)
      TBA            ;transfer [B] to A (contents of B into A)
      CLRB           ;clear B
      TAB            ;transfer [A] to B
      CLR   $0001    ;clear memory address $0001

*Arithmatic Instructions
      ADDA  #$35     ;add A with '$35'
      ADDB  #$79     ;add B with '$79'
      ADDA  #$78     ;add A with '$78'
      SUBB  #$67     ;subtract B with '$67'
      ADDB  $0004    ;add B with 'byte' from mem. address $0004
      SUBA  $0004    ;subtract A with 'byte' from mem. address $0004

*Logical Instructions
      ANDA  #$F0     ;AND A with '11110000'(mask off lower 4-bits)
      ORAA  #$0F     ;OR A with '00001111'
      EORA  #$F0     ;exclusive-OR A with '11110000'
      ANDA  #$00     ;AND A with '00000000'
      ANDA  $0000    ;AND A with 'byte' from mem. address $0004
      ORAB  $0004    ;OR A with 'byte' from mem. address $0004
      COMA           ;complement [A] (Not A)
      COMB           ;complement [B] (Not B)

*Shift and rotate instructions
      LSLB           ;logical shift-left B
      LSRB           ;logical shift-right B
      ASLB           ;arithmetic shift-left B
      ASRB           ;arithmetic shift-right B
      SEC            ;set Carry-bit in CCR
      ROLB           ;rotate-l
      RORB           ;rotate-rght B
      LSL   $0004    ;logical shift-left 'byte' in mem. address $0004
      END












