******************************************************************************
* Program LAB7B.ASM to flash LEDs of ports B and C
* When [PORTB] = $FF, [PORTC] = $00. Values are interchanged after every 200 mSec.
* Each state stays for about 200 mSec for visible flashing
******************************************************************************

PORTB       EQU        $1004      ;
PORTC       EQU        $1003
DDRC        EQU        $1007

* Reset vector allows 'User Reset' button to start program execution....
            ORG        $FFFE     ;reset vector
            FDB        START

* Main program ................................
            ORG        $E200     ;selected program origins

* stack should be defined if subroutines are used
START       LDS        #$00FF    ;define Stack

            LDAA       #$FF      ;load Acc with '$FF'
            STAA       DDRC      ;config Port C as output
* to turn LEDs of port B On
LOOP        STAA       PORTB     ;'11111111' ==>PORTB

* to turn LEDs of port C Off
            COMA                 ;complement Acc to 'zeros'
            STAA       PORTC     ;send zeros to PORTC

* delay 0.2 seccond
            BSR        MS200     ;branch to delay subroutine

            BRA        LOOP      ;CPU branches to LOOP

*subroutine MS200 delays about 200 milli-seconds for timing purpose

MS200       PSHX                 ;save X by pushing [X] into stack
            LDX        #$0101    ;init X with '$FFF0'for 200 ms
XLOOP       DEX                  ;decrement X, [X] = [X]-1
            BNE        XLOOP     ;decrement again if [X] not = zero
            PULX                 ;pull [X] or return [X] from stack
            RTS                  ;return from  subroutine
            END
*
