*************************************************************************
* Program LAB8A.ASM to display a number on the LED numeric board.
*************************************************************************
PORTA       EQU        $00
PORTB       EQU        $04
PORTC       EQU        $03
DDRC        EQU        $07


* Reset vector allows 'User Reset' to start program
            ORG        $FFFE     ;reset vector
            FDB        START

* Main program start here..........
            ORG        $E000     ;program origins - address $E000
START       LDS        #$00FF    ;setup stack
            LDX        #$1000
CHECK       BRCLR      PORTA,X,$01,SWOFF
            JSR        DLY1
            BRCLR      PORTA,X,$02,SWON
            JSR        DLY1
            BRA        CHECK
SWOFF       BCLR       PORTA,X,$20
            BRA        CHECK
SWON        BSET       PORTA,X,$20
            BRA        CHECK


*            STAA       DDRC      ;config Port C as Input
*            CLR        PORTB     ;blank out LED segments
*            CLR        PORTC     ;selects no digit
*            LDAA       #%00000001  ;choose a digit on Numeric Board
*            STAA       PORTC
*            LDAB       #%01111111 ;8-bit code to display '8'
*            STAB       PORTB
*HERE        BRA        HERE

* Subroutine DLY1, if used, will cause a 'time delay' of about 1 second
* CPU loops with 'loop counts'in X(=$FFFF) and Y($0005)
* 'Time Delay' can be changed by changing the 'loop counts'
* Total Time = E-clock period x {((65,535x(3+3)+11)x5 + 25}

DLY1        PSHX                 ;Save X and Y
            PSHY
            LDY        #$0005    ;multiplier=5
LOOP1       LDX        #$0041    ;init loop1 (=65,535)
LOOP2       DEX                  ; --> 3 E-clock cycles
            BNE        LOOP2     ; --> 3  ...
            DEY                  ; --> 4  ...
            BNE        LOOP1     ; --> 3  ...
            PULY                 ;return Y and X
            PULX
            RTS
            END


